package com.exparrot.pete.stats;

/** A class that implements a Poisson distribution, it's not very smart about
 * it but it's clear */
public class Poisson {

	private double mean;
	private double emean;
	
	public Poisson(double mean) {
		this.mean = mean;

		emean = java.lang.Math.exp(-mean);
	}

	/** Returns a random number from the distribution */
	public int getSample() {

		//First get a random number 
		double rnd = java.lang.Math.random();

		double prob = 0.0;
		int x = 0;
		
		//Work our way to the next descrete number until we get there
		while (true) {
			prob = prob + probabilityX(x);
			if (prob > rnd) {
				return x;
			}
			x++;
		}

	}

		
	public double probabilityX(int x) {

		// P(x) = (e ^ - (mean))  * (mean ^ x) / x!
		
		return emean * (java.lang.Math.pow(mean,x)) / factorial(x);

	}

	/** Returns the factorial of x */
	public long factorial(long x) {

		if (x > 1) {
			return factorial(x-1) * x;
		}
		return 1;
	}

	
	public static void main(String[] args) {
		System.out.println("Poisson distribution");
		System.out.println("Mean & Variance " + args[0] + " Number of samples " + args[1]);

		double mean = java.lang.Double.parseDouble(args[0]);
		int samples = java.lang.Integer.parseInt(args[1]);
		Poisson p = new Poisson(mean);
		int[] buckets = new int[(int) (mean * 6)];
		for (int i = 0; i < samples; i++) {
			buckets[p.getSample()]++;
		}
		
		int tmp = 0;
		for (int i = 0; i < buckets.length; i++) {
			System.out.println("No : " + i + " : " + buckets[i]);
			tmp += buckets[i] * i;
		}

		System.out.println("Mean " + ((double)tmp / (double)samples));

		
	}

}
